{Copyright (C) [1999]  [Benito van der Zander]
 All rights reserved.

 Change history:
   10.08.05: Everything of this component was changed and updated

 How you can contact me:
   Mail: BeniBela@aol.com
   WWW:  http://www.benibela.de

 This program is distributed unter the terms of the BSD license:
   Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * The names of its contributors may not be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  }
unit Zahlbox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,ExtCtrls;

type
  TZahlbox = class(TEdit)
  private
  { Private-Deklarationen}
   _numberInt: integer;
   _numberExt: extended;
   _decimalAllowed: boolean;
   _negativeAllowed:boolean;
   procedure setDecimalAllowed(const new:boolean);
   procedure setNegativeAllowed(const new:boolean);
  protected
    { Protected-Deklarationen}
   procedure Change;override;

  public
    { Public-Deklarationen}
    constructor Create(AOwner: TComponent); override;
    function IsInteger(const number:string):Boolean;
    function IsExtended(const number:string):Boolean;
  published
    { Published-Deklarationen }
    property OnKeyPress;
    property allowDecimal: boolean read _decimalAllowed write setDecimalAllowed;
    property allowNegative: boolean read _NegativeAllowed write setNegativeAllowed;
    property NumberInt:integer read _numberInt;
    property numberExtended:extended read _numberExt;
  end;

procedure Register;

implementation


constructor TZahlBox.Create (AOwner: TComponent);
begin
  inherited Create(AOwner);
  _numberInt:=0;
  _numberExt:=0;
  _decimalAllowed:=false;
  _negativeAllowed:=true;
  text:='0';
end;


function TZahlBox.IsInteger(const number:string):Boolean;
var dummy:integer;
begin
  try
    result:=true;
    dummy:=StrToInt(number);
  except
    result:=false;
  end;
end;

function TZahlBox.IsExtended(const number:string):Boolean;
var dummy:extended;
begin
  try
    result:=true;
    dummy:=StrToFloat(number);
  except
    result:=false;
  end;
end;

procedure TZahlBox.Change;
begin
  if (text='')or(text='-') then begin
    _numberInt:=0;
    _numberExt:=0;
  end else begin
    if IsInteger(text) then begin
      _numberInt:=StrToInt(text);
      _numberExt:=_numberInt;
    end else if IsExtended(text)and _decimalAllowed then begin
      _numberExt:=StrToFloat(text);
      _numberInt:=trunc(_numberInt);
    end else begin
      text:='0';
      exit;
    end;
    if (_numberExt<0) and (not _negativeAllowed) then begin
      text:='0';
      exit;
    end;
  end;
  inherited;
end;
procedure TZahlBox.setDecimalAllowed(const new:boolean);
begin
  _decimalAllowed:=new;
  if _numberInt<>_numberExt then text:=IntToStr(_numberInt);
end;
procedure TZahlBox.setNegativeAllowed(const new:boolean);
begin
  _negativeAllowed:=new;
  if _numberExt<0 then text:='0';
end;
procedure Register;
begin
  RegisterComponents('BeniBela', [TZahlbox]);
end;

end.
